import { DataMessage, CompleteMessage, ErrorMessage } from './messages';
import { Observable } from 'rxjs';
declare type IncomingMessage = DataMessage | CompleteMessage | ErrorMessage;
export interface BinaryRxClientParams {
    send: (message: Uint8Array) => void;
    bufferSize?: number;
    bufferTime?: number;
}
export declare class BinaryRxClient {
    private id;
    private readonly buffer;
    private encoder;
    private readonly observers;
    constructor({ send, bufferSize, bufferTime }: BinaryRxClientParams);
    private sendSubscribe;
    private sendUnsubscribe;
    private onData;
    private onComplete;
    private onError;
    onArray(arr: Uint8Array): void;
    onMessages(messages: IncomingMessage[]): void;
    call(method: string, data: Uint8Array): Observable<unknown>;
    notify(method: string, data: undefined | Uint8Array): void;
    stop(): void;
}
export {};
