import type { ITimestamp } from './clock';
import { DeleteOperation } from './operations/DeleteOperation';
import { InsertArrayElementsOperation } from './operations/InsertArrayElementsOperation';
import { InsertStringSubstringOperation } from './operations/InsertStringSubstringOperation';
import { MakeArrayOperation } from './operations/MakeArrayOperation';
import { MakeConstantOperation } from './operations/MakeConstantOperation';
import { MakeNumberOperation } from './operations/MakeNumberOperation';
import { MakeObjectOperation } from './operations/MakeObjectOperation';
import { MakeStringOperation } from './operations/MakeStringOperation';
import { MakeValueOperation } from './operations/MakeValueOperation';
import { NoopOperation } from './operations/NoopOperation';
import { SetNumberOperation } from './operations/SetNumberOperation';
import { SetObjectKeysOperation } from './operations/SetObjectKeysOperation';
import { SetRootOperation } from './operations/SetRootOperation';
import { SetValueOperation } from './operations/SetValueOperation';
export declare type JsonCrdtPatchOperation = DeleteOperation | InsertArrayElementsOperation | InsertStringSubstringOperation | MakeArrayOperation | MakeConstantOperation | MakeNumberOperation | MakeObjectOperation | MakeStringOperation | MakeValueOperation | NoopOperation | SetNumberOperation | SetValueOperation | SetObjectKeysOperation | SetRootOperation;
export declare class Patch {
    readonly ops: JsonCrdtPatchOperation[];
    constructor();
    getId(): ITimestamp | undefined;
    span(): number;
    nextTime(): number;
}
