"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Patch = void 0;
class Patch {
    constructor() {
        this.ops = [];
    }
    getId() {
        const op = this.ops[0];
        if (!op)
            return undefined;
        return op.id;
    }
    span() {
        let span = 0;
        for (const op of this.ops)
            span += op.span();
        return span;
    }
    nextTime() {
        if (!this.ops.length)
            return 0;
        const lastOp = this.ops[this.ops.length - 1];
        return lastOp.id.time + lastOp.span();
    }
}
exports.Patch = Patch;
