import { IClock, ITimespan, ITimestamp, IVectorClock } from './types';
export declare class ServerTimestamp implements ITimestamp {
    time: number;
    constructor(time: number);
    getSessionId(): number;
    isEqual(ts: ITimestamp): boolean;
    compare(ts: ITimestamp): -1 | 0 | 1;
    inSpan(span: number, ts: ITimestamp, tsSpan: number): boolean;
    overlap(span: number, ts: ITimestamp, tsSpan: number): number;
    tick(cycles: number): ITimestamp;
    interval(cycles: number, span: number): ITimespan;
    toString(): string;
    toDisplayString(): string;
    clock(): IClock;
    compact(): string;
}
export declare class ServerTimespan extends ServerTimestamp implements ITimespan {
    span: number;
    constructor(time: number, span: number);
}
export declare class ServerClock extends ServerTimestamp implements IClock {
    tick(cycles: number): ITimestamp;
}
export declare class ServerVectorClock extends ServerClock implements IVectorClock {
    readonly clocks: Map<number, ITimestamp>;
    observe(ts: ITimestamp, span: number): void;
    clone(): ServerVectorClock;
    fork(): ServerVectorClock;
}
