"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeVarUint = exports.encodeVarUInt = void 0;
const encodeVarUInt = (uint) => {
    if (uint <= 0b01111111)
        return [uint];
    if (uint <= 32767)
        return [0b10000000 | (uint & 0b1111111), (uint & 16256) >> 7];
    if (uint <= 8388607)
        return [
            0b10000000 | (uint & 0b1111111),
            0b10000000 | ((uint & 16256) >> 7),
            (uint & 2080768) >> 14,
        ];
    return [
        0b10000000 | (uint & 0b1111111),
        0b10000000 | ((uint & 16256) >> 7),
        0b10000000 | ((uint & 2080768) >> 14),
        (uint & 534773760) >> 21,
    ];
};
exports.encodeVarUInt = encodeVarUInt;
const decodeVarUint = (buf, offset) => {
    const o1 = buf[offset];
    if (o1 <= 127)
        return o1;
    const o2 = buf[offset + 1];
    if (o2 <= 127)
        return (o2 << 7) + (o1 & 127);
    const o3 = buf[offset + 2];
    if (o3 <= 127)
        return (o3 << 14) + ((o2 & 127) << 7) + (o1 & 127);
    const o4 = buf[offset + 3];
    return (o4 << 21) + ((o3 & 127) << 14) + ((o2 & 127) << 7) + (o1 & 127);
};
exports.decodeVarUint = decodeVarUint;
