import { ITimestamp } from '../../../json-crdt-patch/clock';
import { Decoder as MessagePackDecoder } from '../../../json-pack/Decoder';
import { Model } from '../../model';
import type { JsonNode } from '../../types';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { ArrayType } from '../../types/rga-array/ArrayType';
import { StringType } from '../../types/rga-string/StringType';
export declare abstract class AbstractDecoder extends MessagePackDecoder {
    protected doc: Model;
    protected abstract ts(): ITimestamp;
    protected decodeRoot(doc: Model): void;
    decodeNode(): JsonNode;
    private createConst;
    decodeObj(length: number): ObjectType;
    private decodeObjChunk;
    decodeArr(length: number): ArrayType;
    private decodeArrChunk;
    decodeStr(length: number): StringType;
    private decodeStrChunk;
    private decodeVal;
    id(): [x: number, y: number];
    vuint57(): number;
    vuint39(): number;
    b1vuint56(): [flag: boolean, value56: number];
    b1vuint28(): [flag: boolean, value56: number];
    uint53vuint39(): [x: number, z: number];
}
