"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogicalDecoder = void 0;
const ClockDecoder_1 = require("../../../json-crdt-patch/codec/clock/ClockDecoder");
const model_1 = require("../../model");
const AbstractDecoder_1 = require("./AbstractDecoder");
class LogicalDecoder extends AbstractDecoder_1.AbstractDecoder {
    decode(data) {
        this.reset(data);
        const [, clockTableLength] = this.b1vuint56();
        this.decodeClockTable(clockTableLength);
        const doc = (this.doc = model_1.Model.withLogicalClock(this.clockDecoder.clock));
        this.decodeRoot(doc);
        return doc;
    }
    decodeClockTable(length) {
        const firstTimestamp = this.uint53vuint39();
        this.clockDecoder = new ClockDecoder_1.ClockDecoder(firstTimestamp[0], firstTimestamp[1]);
        for (let i = 1; i < length; i++) {
            const ts = this.uint53vuint39();
            this.clockDecoder.pushTuple(ts[0], ts[1]);
        }
    }
    ts() {
        const id = this.id();
        return this.clockDecoder.decodeId(id[0], id[1]);
    }
}
exports.LogicalDecoder = LogicalDecoder;
