"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogicalDecoder = void 0;
const clock_1 = require("../../../json-crdt-patch/clock");
const model_1 = require("../../model");
const AbstractDecoder_1 = require("./AbstractDecoder");
class LogicalDecoder extends AbstractDecoder_1.AbstractDecoder {
    decode({ clock, root }) {
        const vectorClock = this.decodeClock(clock);
        const doc = model_1.Model.withLogicalClock(vectorClock);
        this.decodeRoot(doc, root);
        return doc;
    }
    decodeClock(timestamps) {
        const [ts] = timestamps;
        const vectorClock = new clock_1.LogicalVectorClock(ts[0], ts[1]);
        const length = timestamps.length;
        for (let i = 0; i < length; i++) {
            const ts = timestamps[i];
            const [sessionId, time] = ts;
            vectorClock.observe(new clock_1.LogicalTimestamp(sessionId, time), 1);
        }
        return vectorClock;
    }
    decodeTimestamp([sessionId, time]) {
        return new clock_1.LogicalTimestamp(sessionId, time);
    }
}
exports.LogicalDecoder = LogicalDecoder;
