"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogicalEncoder = void 0;
const AbstractEncoder_1 = require("./AbstractEncoder");
class LogicalEncoder extends AbstractEncoder_1.AbstractEncoder {
    encode(model) {
        const snapshot = {
            clock: this.encodeClock(model.clock),
            root: this.encodeRoot(model.root),
        };
        return snapshot;
    }
    encodeClock(clock) {
        const data = [];
        const sessionId = clock.getSessionId();
        const localTs = clock.clocks.get(sessionId);
        if (!localTs)
            data.push([sessionId, clock.time]);
        for (const c of clock.clocks.values())
            data.push([c.getSessionId(), c.time]);
        return data;
    }
    encodeTimestamp(ts) {
        return [ts.getSessionId(), ts.time];
    }
}
exports.LogicalEncoder = LogicalEncoder;
