"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerDecoder = void 0;
const clock_1 = require("../../../json-crdt-patch/clock");
const model_1 = require("../../model");
const AbstractDecoder_1 = require("./AbstractDecoder");
class ServerDecoder extends AbstractDecoder_1.AbstractDecoder {
    decode({ time, root }) {
        const doc = model_1.Model.withServerClock(time);
        this.decodeRoot(doc, root);
        return doc;
    }
    decodeTimestamp(time) {
        return new clock_1.ServerTimestamp(time);
    }
}
exports.ServerDecoder = ServerDecoder;
