"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DocRootType = void 0;
const constants_1 = require("../../../json-crdt-patch/constants");
class DocRootType {
    constructor(doc, id, node) {
        this.doc = doc;
        this.id = id;
        this.node = node;
    }
    insert(op) {
        if (!this.node) {
            this.set(op.id, op.value);
            return null;
        }
        else if (op.id.compare(this.id) > 0) {
            const node = this.node;
            this.set(op.id, op.value);
            return node.id;
        }
        return null;
    }
    set(id, value) {
        const node = this.doc.node(value);
        if (!node)
            return;
        this.id = id;
        this.node = node;
    }
    toValue() {
        return this.node ? this.node.id : constants_1.UNDEFINED_ID;
    }
    toJson() {
        return !this.node ? undefined : this.node.toJson();
    }
    toString(tab = '') {
        return this.node ? this.node.toString(tab) : 'undefined';
    }
    clone(doc) {
        return new DocRootType(doc, this.id, this.node ? this.node.clone(doc) : null);
    }
    *children() {
        if (this.node)
            yield this.node.id;
    }
}
exports.DocRootType = DocRootType;
