import { Encoder as BaseEncoder } from '../../util/encoder';
import { JsonPackExtension } from '../JsonPackExtension';
import { IMessagePackEncoder } from './types';
export declare class Encoder extends BaseEncoder implements IMessagePackEncoder {
    encode(json: unknown): Uint8Array;
    encodeAny(json: unknown): void;
    encodeNumber(num: number): void;
    encodeStringHeader(length: number): void;
    encodeString(str: string): void;
    encodeArrayHeader(length: number): void;
    encodeArray(arr: unknown[]): void;
    encodeObjectHeader(length: number): void;
    encodeObject(obj: Record<string, unknown>): void;
    buf(buf: Uint8Array, length: number): void;
    encodeExtHeader(type: number, length: number): void;
    encodeExt(ext: JsonPackExtension): void;
}
