"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpDefined = void 0;
const AbstractPredicateOp_1 = require("./AbstractPredicateOp");
const json_pointer_1 = require("../../json-pointer");
class OpDefined extends AbstractPredicateOp_1.AbstractPredicateOp {
    constructor(path) {
        super(path);
    }
    op() {
        return 'defined';
    }
    test(doc) {
        const { val } = json_pointer_1.find(doc, this.path);
        const test = val !== undefined;
        return test;
    }
    toJson(parent) {
        const op = {
            op: 'defined',
            path: json_pointer_1.formatJsonPointer(parent ? this.path.slice(parent.path.length) : this.path),
        };
        return op;
    }
    toCompact(parent) {
        return [31, parent ? this.path.slice(parent.path.length) : this.path];
    }
    encode(encoder, parent) {
        encoder.encodeArrayHeader(2);
        encoder.u8(31);
        encoder.encodeArray(parent ? this.path.slice(parent.path.length) : this.path);
    }
}
exports.OpDefined = OpDefined;
