"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpFlip = void 0;
const AbstractOp_1 = require("./AbstractOp");
const json_pointer_1 = require("../../json-pointer");
class OpFlip extends AbstractOp_1.AbstractOp {
    constructor(path) {
        super(path);
    }
    op() {
        return 'flip';
    }
    apply(doc) {
        const ref = json_pointer_1.find(doc, this.path);
        if (ref.obj)
            ref.obj[ref.key] = !ref.val;
        else
            doc = !ref.val;
        return { doc, old: ref.val };
    }
    toJson(parent) {
        const op = {
            op: 'flip',
            path: json_pointer_1.formatJsonPointer(this.path),
        };
        return op;
    }
    toCompact(parent) {
        return [8, this.path];
    }
    encode(encoder, parent) {
        encoder.encodeArrayHeader(2);
        encoder.u8(8);
        encoder.encodeArray(this.path);
    }
}
exports.OpFlip = OpFlip;
