import type { CompactMergeOp } from '../codec/compact/types';
import { AbstractOp } from './AbstractOp';
import { OperationMerge } from '../types';
import { Path } from '../../json-pointer';
import { IMessagePackEncoder } from '../../json-pack/Encoder/types';
export declare class OpMerge extends AbstractOp<'merge'> {
    readonly pos: number;
    readonly props: object | null;
    constructor(path: Path, pos: number, props: object | null);
    op(): "merge";
    apply(doc: unknown): {
        doc: unknown;
        old: unknown[];
    };
    private merge;
    toJson(parent?: AbstractOp): OperationMerge;
    toCompact(parent?: AbstractOp): CompactMergeOp;
    encode(encoder: IMessagePackEncoder, parent?: AbstractOp): void;
}
