"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Decoder = void 0;
const decode_1 = require("../binary/decode");
const Decoder_1 = require("../../../../json-pack/Decoder");
const isUint8Array_1 = require("../../../../util/isUint8Array");
class Decoder {
    constructor() {
        this.msgpack = new Decoder_1.Decoder();
    }
    convertMessage(message) {
        const data = message.data;
        if (isUint8Array_1.isUint8Array(data)) {
            if (!data.byteLength)
                message.data = undefined;
            else
                message.data = this.msgpack.decode(data);
        }
        return message;
    }
    decode(arr) {
        const binaryMessages = decode_1.decodeFullMessages(arr, 0, arr.byteLength);
        const messages = [];
        const length = binaryMessages.length;
        for (let i = 0; i < length; i++)
            messages.push(this.convertMessage(binaryMessages[i]));
        return messages;
    }
}
exports.Decoder = Decoder;
