import { Observable, ReplaySubject } from 'rxjs';
import { Codec } from '../codec/types';
import { RpcClientParams } from '../rpc';
import { RpcDuplex } from '../rpc/RpcDuplex';
import { RpcServerParams } from '../rpc/RpcServer';
import { PersistentChannel, PersistentChannelParams } from '../channel/channel';
export interface RpcPersistentChannelParams<Ctx = unknown, T = unknown> {
    channel: PersistentChannelParams;
    codec: Codec<string | Uint8Array>;
    client: Omit<RpcClientParams<T>, 'send'>;
    server: Omit<RpcServerParams<Ctx, T>, 'send'>;
}
export declare class RpcPersistentChannel<Ctx = unknown, T = unknown> {
    channel: PersistentChannel;
    rpc?: RpcDuplex<Ctx, T>;
    readonly rpc$: ReplaySubject<RpcDuplex<Ctx, T>>;
    constructor(params: RpcPersistentChannelParams<Ctx, T>);
    start(): void;
    stop(): void;
    call$(method: string, data: T | Observable<T>): Observable<T>;
    notify(method: string, data: T): void;
}
