import { IClock, IVectorClock, ITimespan, ITimestamp } from './types';
export declare class LogicalTimestamp implements ITimestamp {
    sessionId: number;
    time: number;
    constructor(sessionId: number, time: number);
    getSessionId(): number;
    isEqual(ts: ITimestamp): boolean;
    compare(ts: ITimestamp): -1 | 0 | 1;
    inSpan(span: number, ts: ITimestamp, tsSpan: number): boolean;
    overlap(span: number, ts: ITimestamp, tsSpan: number): number;
    tick(cycles: number): ITimestamp;
    interval(cycles: number, span: number): ITimespan;
    toString(): string;
    toDisplayString(): string;
    clock(): IClock;
    compact(): string;
}
export declare class LogicalTimespan extends LogicalTimestamp implements ITimespan {
    span: number;
    constructor(sessionId: number, time: number, span: number);
}
export declare class LogicalClock extends LogicalTimestamp implements IClock {
    tick(cycles: number): ITimestamp;
}
export declare class LogicalVectorClock extends LogicalClock implements IVectorClock {
    readonly clocks: Map<number, ITimestamp>;
    observe(ts: ITimestamp, span: number): void;
    clone(): LogicalVectorClock;
    fork(sessionId: number): LogicalVectorClock;
}
