import { ClockDecoder } from '../../../json-crdt-patch/codec/clock/ClockDecoder';
import { Model } from '../../model';
import { AbstractDecoder } from './AbstractDecoder';
export class LogicalDecoder extends AbstractDecoder {
    decode(data) {
        this.reset(data);
        const [, clockTableLength] = this.b1vuint56();
        this.decodeClockTable(clockTableLength);
        const doc = (this.doc = Model.withLogicalClock(this.clockDecoder.clock));
        this.decodeRoot(doc);
        return doc;
    }
    decodeClockTable(length) {
        const firstTimestamp = this.uint53vuint39();
        this.clockDecoder = new ClockDecoder(firstTimestamp[0], firstTimestamp[1]);
        for (let i = 1; i < length; i++) {
            const ts = this.uint53vuint39();
            this.clockDecoder.pushTuple(ts[0], ts[1]);
        }
    }
    ts() {
        const id = this.id();
        return this.clockDecoder.decodeId(id[0], id[1]);
    }
}
