import { ClockEncoder } from '../../../json-crdt-patch/codec/clock/ClockEncoder';
import { AbstractEncoder } from './AbstractEncoder';
export class LogicalEncoder extends AbstractEncoder {
    encode(doc) {
        this.reset();
        this.clockEncoder = new ClockEncoder(doc.clock);
        this.encodeRoot(doc.root);
        const data = this.flush();
        this.encodeClockTable(data);
        return this.flush();
    }
    encodeClockTable(data) {
        const { clockEncoder } = this;
        const length = clockEncoder.table.size;
        const dataSize = data.byteLength;
        this.uint8 = new Uint8Array(8 + 12 * length + dataSize);
        this.view = new DataView(this.uint8.buffer, this.uint8.byteOffset, this.uint8.byteLength);
        this.offset = 0;
        this.vuint57(length);
        for (const sid of clockEncoder.table.keys()) {
            const ts = clockEncoder.clock.clocks.get(sid);
            if (ts)
                this.uint53vuint39(sid, ts.time);
            else if (sid === clockEncoder.clock.getSessionId())
                this.uint53vuint39(sid, 0);
            else {
            }
        }
        this.buf(data, dataSize);
    }
    ts(ts) {
        const id = this.clockEncoder.append(ts);
        this.id(id.sessionIndex, id.timeDiff);
    }
}
