import type { ITimestamp } from '../../../json-crdt-patch/clock';
import { JsonNode } from '../../types';
import { ConstantType } from '../../types/const/ConstantType';
import { DocRootType } from '../../types/lww-doc-root/DocRootType';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { ValueType } from '../../types/lww-value/ValueType';
import { ArrayChunk } from '../../types/rga-array/ArrayChunk';
import { ArrayType } from '../../types/rga-array/ArrayType';
import { StringChunk } from '../../types/rga-string/StringChunk';
import { StringType } from '../../types/rga-string/StringType';
import { RootJsonCrdtNode, JsonCrdtNode, ObjectJsonCrdtNode, ArrayJsonCrdtNode, ArrayJsonCrdtChunk, JsonCrdtRgaTombstone, ValueJsonCrdtNode, StringJsonCrdtNode, StringJsonCrdtChunk, ConstantJsonCrdtNode } from './types';
export declare abstract class AbstractEncoder<Id> {
    abstract encodeTimestamp(ts: ITimestamp): Id;
    encodeRoot(root: DocRootType): RootJsonCrdtNode<Id>;
    encodeNode(node: JsonNode): JsonCrdtNode<Id>;
    encodeObj(obj: ObjectType): ObjectJsonCrdtNode<Id>;
    encodeArr(obj: ArrayType): ArrayJsonCrdtNode<Id>;
    encodeArrChunk(chunk: ArrayChunk): ArrayJsonCrdtChunk<Id> | JsonCrdtRgaTombstone<Id>;
    encodeStr(obj: StringType): StringJsonCrdtNode<Id>;
    encodeStrChunk(chunk: StringChunk): StringJsonCrdtChunk<Id> | JsonCrdtRgaTombstone<Id>;
    encodeVal(obj: ValueType): ValueJsonCrdtNode<Id>;
    encodeConst(obj: ConstantType): ConstantJsonCrdtNode;
}
