import { LogicalTimestamp, LogicalVectorClock } from '../../../json-crdt-patch/clock';
import { Model } from '../../model';
import { AbstractDecoder } from './AbstractDecoder';
export class LogicalDecoder extends AbstractDecoder {
    decode({ clock, root }) {
        const vectorClock = this.decodeClock(clock);
        const doc = Model.withLogicalClock(vectorClock);
        this.decodeRoot(doc, root);
        return doc;
    }
    decodeClock(timestamps) {
        const [ts] = timestamps;
        const vectorClock = new LogicalVectorClock(ts[0], ts[1]);
        const length = timestamps.length;
        for (let i = 0; i < length; i++) {
            const ts = timestamps[i];
            const [sessionId, time] = ts;
            vectorClock.observe(new LogicalTimestamp(sessionId, time), 1);
        }
        return vectorClock;
    }
    decodeTimestamp([sessionId, time]) {
        return new LogicalTimestamp(sessionId, time);
    }
}
