import { AbstractEncoder } from './AbstractEncoder';
export class LogicalEncoder extends AbstractEncoder {
    encode(model) {
        const snapshot = {
            clock: this.encodeClock(model.clock),
            root: this.encodeRoot(model.root),
        };
        return snapshot;
    }
    encodeClock(clock) {
        const data = [];
        const sessionId = clock.getSessionId();
        const localTs = clock.clocks.get(sessionId);
        if (!localTs)
            data.push([sessionId, clock.time]);
        for (const c of clock.clocks.values())
            data.push([c.getSessionId(), c.time]);
        return data;
    }
    encodeTimestamp(ts) {
        return [ts.getSessionId(), ts.time];
    }
}
