import { JsonPatchDraft } from './JsonPatchDraft';
import { decode } from '../../json-patch/codec/json';
export class JsonPatch {
    constructor(model) {
        this.model = model;
    }
    createDraft(ops) {
        const draft = new JsonPatchDraft(this.model);
        draft.applyOps(ops);
        return draft;
    }
    createCrdtPatch(ops) {
        return this.createDraft(ops).patch(this.model.clock);
    }
    applyPatch(jsonPatch) {
        const ops = decode(jsonPatch);
        const patch = this.createCrdtPatch(ops);
        this.model.clock.tick(patch.span());
        this.model.applyPatch(patch);
    }
}
