export declare type NodeType = 'null' | 'boolean' | 'number' | 'string' | 'array' | 'object';
export interface NodeOdds {
    null: number;
    boolean: number;
    number: number;
    string: number;
    array: number;
    object: number;
}
export interface RandomJsonOptions {
    rootNode: 'object' | 'array' | undefined;
    nodeCount: number;
    odds: NodeOdds;
}
declare type ContainerNode = unknown[] | object;
export declare class RandomJson {
    static generate(opts?: Partial<RandomJsonOptions>): unknown;
    opts: RandomJsonOptions;
    private totalOdds;
    private oddTotals;
    root: unknown[] | object;
    private containers;
    constructor(opts?: Partial<RandomJsonOptions>);
    create(): unknown;
    addNode(): void;
    protected generate(type: NodeType): unknown;
    pickNodeType(): NodeType;
    protected pickContainerType(): 'array' | 'object';
    protected pickContainer(): ContainerNode;
    protected ascii(): string;
    protected utf8(): string;
    protected str(length?: number): string;
}
export {};
