export declare type Id = number;
export declare type Name = string;
export declare type CompactNotificationMessage<Data = unknown> = [Name] | [Name, Data];
export declare type CompactRequestCompleteMessage<Data = unknown> = [Id, Name] | [Id, Name, Data];
export declare type CompactRequestDataMessage<Data = unknown> = [Id, 0, Name] | [Id, 0, Name, Data];
export declare type CompactRequestErrorMessage<Data = unknown> = [Id, 1, Name, Data];
export declare type CompactRequestUnsubscribeMessage = [Id, 2];
export declare type CompactResponseCompleteMessage<Data = unknown> = [0, Id] | [0, Id, Data];
export declare type CompactResponseErrorMessage<Data = unknown> = [-1, Id, Data];
export declare type CompactResponseDataMessage<Data = unknown> = [-2, Id, Data];
export declare type CompactResponseUnsubscribeMessage = [-3, Id];
export declare type CompactMessage = CompactNotificationMessage | CompactRequestDataMessage | CompactRequestCompleteMessage | CompactRequestErrorMessage | CompactRequestUnsubscribeMessage | CompactResponseDataMessage | CompactResponseCompleteMessage | CompactResponseErrorMessage | CompactResponseUnsubscribeMessage;
export declare type CompactMessageBatch = (CompactMessage | CompactMessageBatch)[];
