"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogicalDecoder = void 0;
var tslib_1 = require("tslib");
var ClockDecoder_1 = require("../../../json-crdt-patch/codec/clock/ClockDecoder");
var model_1 = require("../../model");
var AbstractDecoder_1 = require("./AbstractDecoder");
var LogicalDecoder = (function (_super) {
    tslib_1.__extends(LogicalDecoder, _super);
    function LogicalDecoder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LogicalDecoder.prototype.decode = function (data) {
        this.reset(data);
        var _a = tslib_1.__read(this.b1vuint56(), 2), clockTableLength = _a[1];
        this.decodeClockTable(clockTableLength);
        var doc = (this.doc = model_1.Model.withLogicalClock(this.clockDecoder.clock));
        this.decodeRoot(doc);
        return doc;
    };
    LogicalDecoder.prototype.decodeClockTable = function (length) {
        var firstTimestamp = this.uint53vuint39();
        this.clockDecoder = new ClockDecoder_1.ClockDecoder(firstTimestamp[0], firstTimestamp[1]);
        for (var i = 1; i < length; i++) {
            var ts = this.uint53vuint39();
            this.clockDecoder.pushTuple(ts[0], ts[1]);
        }
    };
    LogicalDecoder.prototype.ts = function () {
        var id = this.id();
        return this.clockDecoder.decodeId(id[0], id[1]);
    };
    return LogicalDecoder;
}(AbstractDecoder_1.AbstractDecoder));
exports.LogicalDecoder = LogicalDecoder;
