"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogicalEncoder = void 0;
var tslib_1 = require("tslib");
var ClockEncoder_1 = require("../../../json-crdt-patch/codec/clock/ClockEncoder");
var AbstractEncoder_1 = require("./AbstractEncoder");
var LogicalEncoder = (function (_super) {
    tslib_1.__extends(LogicalEncoder, _super);
    function LogicalEncoder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LogicalEncoder.prototype.encode = function (doc) {
        this.reset();
        this.clockEncoder = new ClockEncoder_1.ClockEncoder(doc.clock);
        this.encodeRoot(doc.root);
        var data = this.flush();
        this.encodeClockTable(data);
        return this.flush();
    };
    LogicalEncoder.prototype.encodeClockTable = function (data) {
        var e_1, _a;
        var clockEncoder = this.clockEncoder;
        var length = clockEncoder.table.size;
        var dataSize = data.byteLength;
        this.uint8 = new Uint8Array(8 + 12 * length + dataSize);
        this.view = new DataView(this.uint8.buffer, this.uint8.byteOffset, this.uint8.byteLength);
        this.offset = 0;
        this.vuint57(length);
        try {
            for (var _b = tslib_1.__values(clockEncoder.table.keys()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var sid = _c.value;
                var ts = clockEncoder.clock.clocks.get(sid);
                if (ts)
                    this.uint53vuint39(sid, ts.time);
                else if (sid === clockEncoder.clock.getSessionId())
                    this.uint53vuint39(sid, 0);
                else {
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.buf(data, dataSize);
    };
    LogicalEncoder.prototype.ts = function (ts) {
        var id = this.clockEncoder.append(ts);
        this.id(id.sessionIndex, id.timeDiff);
    };
    return LogicalEncoder;
}(AbstractEncoder_1.AbstractEncoder));
exports.LogicalEncoder = LogicalEncoder;
