"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogicalDecoder = void 0;
var tslib_1 = require("tslib");
var clock_1 = require("../../../json-crdt-patch/clock");
var model_1 = require("../../model");
var AbstractDecoder_1 = require("./AbstractDecoder");
var LogicalDecoder = (function (_super) {
    tslib_1.__extends(LogicalDecoder, _super);
    function LogicalDecoder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LogicalDecoder.prototype.decode = function (_a) {
        var clock = _a.clock, root = _a.root;
        var vectorClock = this.decodeClock(clock);
        var doc = model_1.Model.withLogicalClock(vectorClock);
        this.decodeRoot(doc, root);
        return doc;
    };
    LogicalDecoder.prototype.decodeClock = function (timestamps) {
        var _a = tslib_1.__read(timestamps, 1), ts = _a[0];
        var vectorClock = new clock_1.LogicalVectorClock(ts[0], ts[1]);
        var length = timestamps.length;
        for (var i = 0; i < length; i++) {
            var ts_1 = timestamps[i];
            var _b = tslib_1.__read(ts_1, 2), sessionId = _b[0], time = _b[1];
            vectorClock.observe(new clock_1.LogicalTimestamp(sessionId, time), 1);
        }
        return vectorClock;
    };
    LogicalDecoder.prototype.decodeTimestamp = function (_a) {
        var _b = tslib_1.__read(_a, 2), sessionId = _b[0], time = _b[1];
        return new clock_1.LogicalTimestamp(sessionId, time);
    };
    return LogicalDecoder;
}(AbstractDecoder_1.AbstractDecoder));
exports.LogicalDecoder = LogicalDecoder;
