"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogicalEncoder = void 0;
var tslib_1 = require("tslib");
var AbstractEncoder_1 = require("./AbstractEncoder");
var LogicalEncoder = (function (_super) {
    tslib_1.__extends(LogicalEncoder, _super);
    function LogicalEncoder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LogicalEncoder.prototype.encode = function (model) {
        var snapshot = {
            clock: this.encodeClock(model.clock),
            root: this.encodeRoot(model.root),
        };
        return snapshot;
    };
    LogicalEncoder.prototype.encodeClock = function (clock) {
        var e_1, _a;
        var data = [];
        var sessionId = clock.getSessionId();
        var localTs = clock.clocks.get(sessionId);
        if (!localTs)
            data.push([sessionId, clock.time]);
        try {
            for (var _b = tslib_1.__values(clock.clocks.values()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                data.push([c.getSessionId(), c.time]);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return data;
    };
    LogicalEncoder.prototype.encodeTimestamp = function (ts) {
        return [ts.getSessionId(), ts.time];
    };
    return LogicalEncoder;
}(AbstractEncoder_1.AbstractEncoder));
exports.LogicalEncoder = LogicalEncoder;
