export interface JsonCrdtLogicalSnapshot {
    clock: JsonCrdtLogicalTimestamp[];
    root: RootJsonCrdtNode<JsonCrdtLogicalTimestamp>;
}
export declare type JsonCrdtLogicalTimestamp = [sessionId: number, time: number];
export interface JsonCrdtServerSnapshot {
    time: JsonCrdtServerTimestamp;
    root: RootJsonCrdtNode<JsonCrdtServerTimestamp>;
}
export declare type JsonCrdtServerTimestamp = number;
export interface RootJsonCrdtNode<Id> {
    type: 'root';
    id: Id;
    node: JsonCrdtNode<Id> | null;
}
export interface ObjectJsonCrdtNode<Id> {
    type: 'obj';
    id: Id;
    chunks: Record<string, ObjectJsonCrdtChunk<Id>>;
}
export interface ObjectJsonCrdtChunk<Id> {
    id: Id;
    node: JsonCrdtNode<Id>;
}
export interface ArrayJsonCrdtNode<Id> {
    type: 'arr';
    id: Id;
    chunks: (ArrayJsonCrdtChunk<Id> | JsonCrdtRgaTombstone<Id>)[];
}
export interface ArrayJsonCrdtChunk<Id> {
    id: Id;
    nodes: JsonCrdtNode<Id>[];
}
export interface StringJsonCrdtNode<Id> {
    type: 'str';
    id: Id;
    chunks: (StringJsonCrdtChunk<Id> | JsonCrdtRgaTombstone<Id>)[];
}
export interface StringJsonCrdtChunk<Id> {
    id: Id;
    value: string;
}
export interface JsonCrdtRgaTombstone<Id> {
    id: Id;
    span: number;
}
export interface ValueJsonCrdtNode<Id> {
    type: 'val';
    id: Id;
    writeId: Id;
    value: unknown;
}
export interface ConstantJsonCrdtNode {
    type: 'const';
    value: unknown;
}
export declare type JsonCrdtNode<Id> = ObjectJsonCrdtNode<Id> | ArrayJsonCrdtNode<Id> | StringJsonCrdtNode<Id> | ValueJsonCrdtNode<Id> | ConstantJsonCrdtNode;
