import type { JsonNode } from '../types/types';
import { NodeIndex } from './nodes';
import { JsonCrdtPatchOperation, Patch } from '../../json-crdt-patch/Patch';
import { ITimestamp, IVectorClock, LogicalVectorClock } from '../../json-crdt-patch/clock';
import { DocRootType } from '../types/lww-doc-root/DocRootType';
import { ModelApi } from './api/ModelApi';
export declare class Model {
    static withLogicalClock(clock?: LogicalVectorClock): Model;
    static withServerClock(time?: number): Model;
    root: DocRootType;
    clock: IVectorClock;
    nodes: NodeIndex<JsonNode>;
    api: ModelApi;
    constructor(clock: IVectorClock, nodes: NodeIndex<JsonNode>);
    node(id: ITimestamp): JsonNode | undefined;
    applyPatch(patch: Patch): void;
    applyOperation(op: JsonCrdtPatchOperation): void;
    private deleteNodeTree;
    clone(): Model;
    fork(sessionId?: number): Model;
    toJson(): unknown;
    toString(tab?: string): string;
}
