import type { Identifiable } from '../../json-crdt-patch/Identifiable';
import type { ITimestamp } from '../../json-crdt-patch/clock';
export interface NodeIndex<T extends Identifiable> {
    get(id: ITimestamp): undefined | T;
    index(operation: T): void;
    delete(id: ITimestamp): void;
    iterate(): IterableIterator<T>;
    random(): T | null;
}
export declare class LogicalNodeIndex<T extends Identifiable> implements NodeIndex<T> {
    entries: Map<number, Map<number, T>>;
    get(id: ITimestamp): undefined | T;
    index(operation: T): void;
    delete(id: ITimestamp): void;
    iterate(): IterableIterator<T>;
    random(): T | null;
}
export declare class ServerNodeIndex<T extends Identifiable> implements NodeIndex<T> {
    entries: Map<number, T>;
    get(id: ITimestamp): undefined | T;
    index(node: T): void;
    delete(id: ITimestamp): void;
    iterate(): IterableIterator<T>;
    random(): T | null;
}
