"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValueType = void 0;
var tslib_1 = require("tslib");
var ValueType = (function () {
    function ValueType(id, writeId, value) {
        this.id = id;
        this.writeId = writeId;
        this.value = value;
    }
    ValueType.prototype.insert = function (op) {
        if (op.id.compare(this.writeId) <= 0)
            return;
        this.writeId = op.id;
        this.value = op.value;
    };
    ValueType.prototype.toJson = function () {
        return this.value;
    };
    ValueType.prototype.toString = function (tab) {
        if (tab === void 0) { tab = ''; }
        return tab + "num(" + this.id.toString() + ") { " + this.toJson() + " }";
    };
    ValueType.prototype.clone = function (doc) {
        var copy = new ValueType(this.id, this.writeId, this.value);
        doc.nodes.index(copy);
        return copy;
    };
    ValueType.prototype.children = function () { return tslib_1.__generator(this, function (_a) {
        return [2];
    }); };
    return ValueType;
}());
exports.ValueType = ValueType;
