"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StringChunk = void 0;
var clock_1 = require("../../../json-crdt-patch/clock");
var StringChunk = (function () {
    function StringChunk(id, str) {
        this.id = id;
        this.str = str;
        this.left = null;
        this.right = null;
    }
    StringChunk.prototype.span = function () {
        return this.deleted || this.str.length;
    };
    StringChunk.prototype.split = function (time) {
        var newSpan = 1 + time - this.id.time;
        var newId = new clock_1.LogicalTimestamp(this.id.getSessionId(), time + 1);
        if (this.str) {
            var newChunkStr = this.str.substr(newSpan);
            this.str = this.str.substr(0, newSpan);
            return new StringChunk(newId, newChunkStr);
        }
        else {
            var chunk = new StringChunk(newId, undefined);
            chunk.deleted = this.span() - newSpan;
            this.deleted = newSpan;
            return chunk;
        }
    };
    StringChunk.prototype.delete = function () {
        this.deleted = this.span();
        delete this.str;
    };
    StringChunk.prototype.merge = function (substring) {
        this.str += substring;
    };
    StringChunk.prototype.clone = function () {
        var chunk = new StringChunk(this.id, this.str);
        if (this.deleted) {
            chunk.deleted = this.deleted;
            delete chunk.str;
        }
        return chunk;
    };
    StringChunk.prototype.toString = function (tab) {
        if (tab === void 0) { tab = ''; }
        var str = tab + "StringChunk(" + this.id.toDisplayString() + ") { " + (!this.str ? "[" + (this.deleted || this.span()) + "]" : this.str.length > 10 ? this.str.substr(0, 10) + '…' : this.str) + " }";
        return str;
    };
    return StringChunk;
}());
exports.StringChunk = StringChunk;
