import type { JsonNode } from '../../types';
import type { Model } from '../../model';
import { ITimestamp, ITimespan } from '../../../json-crdt-patch/clock';
import { DeleteOperation } from '../../../json-crdt-patch/operations/DeleteOperation';
import { InsertStringSubstringOperation } from '../../../json-crdt-patch/operations/InsertStringSubstringOperation';
import { StringChunk } from './StringChunk';
export declare class StringType implements JsonNode {
    readonly doc: Model;
    readonly id: ITimestamp;
    start: StringChunk;
    end: StringChunk;
    constructor(doc: Model, id: ITimestamp);
    onInsert(op: InsertStringSubstringOperation): void;
    onDelete(op: DeleteOperation): void;
    private insertChunk;
    private splitChunk;
    private deleteInChunk;
    findId(index: number): ITimestamp;
    findIdSpan(index: number, length: number): ITimespan[];
    append(chunk: StringChunk): void;
    toJson(): string;
    clone(doc: Model): StringType;
    children(): IterableIterator<ITimestamp>;
    chunks(): IterableIterator<StringChunk>;
    size(): number;
    length(): number;
    toString(tab?: string): string;
}
