"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpTest = void 0;
var tslib_1 = require("tslib");
var json_pointer_1 = require("../../json-pointer");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
var isEqual = require('fast-deep-equal');
var OpTest = (function (_super) {
    tslib_1.__extends(OpTest, _super);
    function OpTest(path, value, not) {
        var _this = _super.call(this, path) || this;
        _this.value = value;
        _this.not = not;
        return _this;
    }
    OpTest.prototype.op = function () {
        return 'test';
    };
    OpTest.prototype.test = function (doc) {
        var val = json_pointer_1.find(doc, this.path).val;
        if (val === undefined)
            return !!this.not;
        var test = isEqual(val, this.value);
        return this.not ? !test : test;
    };
    OpTest.prototype.toJson = function (parent) {
        var op = {
            op: 'test',
            path: json_pointer_1.formatJsonPointer(parent ? this.path.slice(parent.path.length) : this.path),
            value: this.value,
        };
        if (this.not)
            op.not = this.not;
        return op;
    };
    OpTest.prototype.toCompact = function (parent) {
        var path = parent ? this.path.slice(parent.path.length) : this.path;
        return this.not
            ? [5, path, this.value, 1]
            : [5, path, this.value];
    };
    OpTest.prototype.encode = function (encoder, parent) {
        encoder.encodeArrayHeader(this.not ? 4 : 3);
        encoder.u8(5);
        encoder.encodeArray(parent ? this.path.slice(parent.path.length) : this.path);
        encoder.encodeAny(this.value);
        if (this.not)
            encoder.u8(1);
    };
    return OpTest;
}(AbstractPredicateOp_1.AbstractPredicateOp));
exports.OpTest = OpTest;
