"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpUndefined = void 0;
var tslib_1 = require("tslib");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
var json_pointer_1 = require("../../json-pointer");
var OpUndefined = (function (_super) {
    tslib_1.__extends(OpUndefined, _super);
    function OpUndefined(path) {
        return _super.call(this, path) || this;
    }
    OpUndefined.prototype.op = function () {
        return 'undefined';
    };
    OpUndefined.prototype.test = function (doc) {
        try {
            var val = json_pointer_1.find(doc, this.path).val;
            var test_1 = val === undefined;
            return test_1;
        }
        catch (error) {
            if (error.message === 'NOT_FOUND')
                return true;
            throw error;
        }
    };
    OpUndefined.prototype.toJson = function (parent) {
        var op = {
            op: 'undefined',
            path: json_pointer_1.formatJsonPointer(parent ? this.path.slice(parent.path.length) : this.path),
        };
        return op;
    };
    OpUndefined.prototype.toCompact = function (parent) {
        return [38, parent ? this.path.slice(parent.path.length) : this.path];
    };
    OpUndefined.prototype.encode = function (encoder, parent) {
        encoder.encodeArrayHeader(2);
        encoder.u8(38);
        encoder.encodeArray(parent ? this.path.slice(parent.path.length) : this.path);
    };
    return OpUndefined;
}(AbstractPredicateOp_1.AbstractPredicateOp));
exports.OpUndefined = OpUndefined;
