"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Decoder = void 0;
var decode_1 = require("../binary/decode");
var Decoder_1 = require("../../../../json-pack/Decoder");
var isUint8Array_1 = require("../../../../util/isUint8Array");
var Decoder = (function () {
    function Decoder() {
        this.msgpack = new Decoder_1.Decoder();
    }
    Decoder.prototype.convertMessage = function (message) {
        var data = message.data;
        if (isUint8Array_1.isUint8Array(data)) {
            if (!data.byteLength)
                message.data = undefined;
            else
                message.data = this.msgpack.decode(data);
        }
        return message;
    };
    Decoder.prototype.decode = function (arr) {
        var binaryMessages = decode_1.decodeFullMessages(arr, 0, arr.byteLength);
        var messages = [];
        var length = binaryMessages.length;
        for (var i = 0; i < length; i++)
            messages.push(this.convertMessage(binaryMessages[i]));
        return messages;
    };
    return Decoder;
}());
exports.Decoder = Decoder;
