"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RpcError = exports.ErrorLikeErrorFormatter = exports.formatErrorCode = exports.formatError = exports.isErrorLike = exports.formatErrorLike = void 0;
var tslib_1 = require("tslib");
var constants_1 = require("./constants");
var formatErrorLike = function (error) {
    var out = { message: error.message };
    if (typeof error.status === 'number')
        out.status = error.status;
    if (typeof error.code === 'string')
        out.code = error.code;
    if (typeof error.errno === 'number')
        out.errno = error.errno;
    if (typeof error.errorId === 'number')
        out.errorId = error.errorId;
    return out;
};
exports.formatErrorLike = formatErrorLike;
var isErrorLike = function (error) {
    if (error instanceof Error)
        return true;
    if (typeof error === 'object')
        if (typeof error.message === 'string')
            return true;
    return false;
};
exports.isErrorLike = isErrorLike;
var formatError = function (error) {
    if (exports.isErrorLike(error))
        return exports.formatErrorLike(error);
    return {
        message: String(error),
    };
};
exports.formatError = formatError;
var formatErrorCode = function (errno) {
    return {
        message: 'PROTOCOL',
        errno: errno,
        code: constants_1.RpcServerError[errno],
    };
};
exports.formatErrorCode = formatErrorCode;
var ErrorLikeErrorFormatter = (function () {
    function ErrorLikeErrorFormatter() {
    }
    ErrorLikeErrorFormatter.prototype.format = function (error) {
        return exports.formatError(error);
    };
    ErrorLikeErrorFormatter.prototype.formatValidation = function (error) {
        return this.format(error);
    };
    ErrorLikeErrorFormatter.prototype.formatCode = function (code) {
        return exports.formatErrorCode(code);
    };
    return ErrorLikeErrorFormatter;
}());
exports.ErrorLikeErrorFormatter = ErrorLikeErrorFormatter;
var RpcError = (function (_super) {
    tslib_1.__extends(RpcError, _super);
    function RpcError(errno, message) {
        if (message === void 0) { message = 'PROTOCOL'; }
        var _this = _super.call(this, message) || this;
        _this.errno = errno;
        _this.code = constants_1.RpcServerError[errno];
        return _this;
    }
    return RpcError;
}(Error));
exports.RpcError = RpcError;
